proc streaming/browser::process {sock {params ""}} {
   Trace
   variable folderopen
   variable folderclosed
   variable playbutton
   variable brform
   set myns [string trim [namespace current] :]
   upvar #0 Httpd$sock data
   set title "SnackAmp Jukebox"
   set css "/snackamp.css"
   set result [leader $title $css]
   append result <body>
   set sortMethod "shuffle"
   if {[string length $params]} {
      foreach param [split $params &]  {
         foreach {CmdType Cmd} [split $param =] {break}
         switch -- $CmdType {
            sort {
               set sortMethod $Cmd
            }
            folder {
               append result "<h1>Media Folders</h1>\n"
               set folders [list]
               set files [list]
               set folder [HttpD::Decode $Cmd]
               set contents [lsort -dictionary [glob -nocomplain -directory $folder *]]
               foreach entry $contents {
                  if {[file isdirectory $entry]} {
                     lappend folders $entry
                  } elseif {[info exists ::taExtensions([file extension $entry])]} {
                     lappend files $entry
                  }
               } ;# end foreach
               #----------------------------
               ;##
               ;# Create a list of all folders, includling toplevel ones
               ;#
               set fldr $folder
               while {1} {
                  ;# Get list of all parent folders
                  set under [file dirname $fldr]
                  if {[string equal $under $fldr]} {
                     break
                  } else {
                     lappend folders $fldr ;########
                     set fldr $under
                  }
               }
               ;# List of toplevel folder
               foreach item $::snackAmpSettings(mediaDirs) {
                  lappend folders $item
                  if {[string match "$item*" $folder]} {
                     set icon $folderopen
                  } else {
                     set icon $folderclosed
                  }
                  append result "$icon <a href=/$myns?folder=[HttpD::Encode $item]>$item</a><br>\n"
               } ;# end foreach
               #----------------------------
               set folders [lsort -unique $folders]
               ;# Show the folders
               if {[llength $folders]} {
                  append result "<hr>\n"
                  append result $brform
                  append result "<h1>Current Folder $folder</h1>\n"
                  append result {<table border="1" cellpadding="0" cellspacing="0" class="songPlaylist">}
                  ;# Find minimum folder length for indent offsets
                  foreach item $folders {
                     lappend reps [llength [file split $item]]
                  }
                  set minrep [lindex [lsort -integer $reps] 0]
                  foreach item $folders {
                     set icon $folderclosed
                     if {[string equal $item $folder]} {
                        set icon $folderopen
                     }
                     set rep [expr {[llength [file split $item]]-$minrep}]
                     set link "[string repeat &nbsp $rep]$icon <a href=/$myns?sort=\"$sortMethod\"&folder=[HttpD::Encode $item]>$item</a><br>\n"
                     ;# S = Stream folder contents
                     ;# T = Tracks for folder contents
                     set url [string map {' \\'} $item]
                     set base "/streaming/getplaylist.pls"
                     set F [subst {<a href="javascript:foldersel('$base','$url')"><img border=0 src=/images/play.png></A>}]
                     append result [httpHelpers::tableRow [list $F $link] darkRows]
                  } ;# end foreach
                  append result "</table>\n"
               }
               ;# Show the files
               if {[llength $files]} {
                  append result "<hr>\n"
                  append result "<h1>Tracks within $folder</h1>\n"
                  append result {<table border="1" cellpadding="0" cellspacing="0" class="songPlaylist">}
                  foreach file $files {
                     set ref [string map {' \\'} $file]
                     set I [subst {<a href="javascript:popupInfo('/remote/jukebox/?question=$ref',200,600,'Info')"><img border=0 src=/images/info.png></A>}]
                     set link "<a href=/streaming/getplaylist.pls?sort=\"$sortMethod\"&track=[HttpD::Encode $file]>$playbutton</a><br>\n"
                     set size "[commify [expr {[file size $file]/1024}]] KB"
                     append result [httpHelpers::tableRow [list $I $link [file tail $file] $size] lightRows]
                  } ;# end foreach
                  append result "</table>\n"
               } else {
                  append result "<hr>\n"
                  append result "<h1>No Tracks within $folder</h1>\n"
               }
            }
         } ;# End Switch
      }
   } else {
      append result "<h1>SnackAmp Folder Browser</h1>\n"
      append result "<h2>Please Select a Folder Below to Browse</h2>\n"
      foreach folder $::snackAmpSettings(mediaDirs) {
         append result "$folderclosed <a href=/$myns?folder=[HttpD::Encode $folder]>$folder</a><br>\n"
      } ;# end foreach
   }
   append result "</body>\n</html>\n"
   return [list dhtml html [string trim $result]]
}

